Index: uspace/lib/c/generic/async.c
===================================================================
--- uspace/lib/c/generic/async.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/lib/c/generic/async.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -1048,14 +1048,14 @@
  *
  * @param inr     IRQ number.
+ * @param devno   Device number of the device generating inr.
  * @param handler Notification handler.
  * @param data    Notification handler client data.
  * @param ucode   Top-half pseudocode handler.
  *
- * @return IRQ capability handle on success.
- * @return Negative error code.
- *
- */
-int async_irq_subscribe(int inr, async_notification_handler_t handler,
-    void *data, const irq_code_t *ucode)
+ * @return Zero on success or a negative error code.
+ *
+ */
+int async_irq_subscribe(int inr, int devno,
+    async_notification_handler_t handler, void *data, const irq_code_t *ucode)
 {
 	notification_t *notification =
@@ -1077,20 +1077,21 @@
 	futex_up(&async_futex);
 	
-	return ipc_irq_subscribe(inr, imethod, ucode);
+	return ipc_irq_subscribe(inr, devno, imethod, ucode);
 }
 
 /** Unsubscribe from IRQ notification.
  *
- * @param cap     IRQ capability handle. 
+ * @param inr     IRQ number.
+ * @param devno   Device number of the device generating inr.
  *
  * @return Zero on success or a negative error code.
  *
  */
-int async_irq_unsubscribe(int cap)
+int async_irq_unsubscribe(int inr, int devno)
 {
 	// TODO: Remove entry from hash table
 	//       to avoid memory leak
 	
-	return ipc_irq_unsubscribe(cap);
+	return ipc_irq_unsubscribe(inr, devno);
 }
 
@@ -1383,4 +1384,14 @@
 		async_new_connection(call->in_task_id, in_phone_hash, callid,
 		    call, handler, data);
+		return;
+	}
+	
+	/* Cloned connection */
+	if (IPC_GET_IMETHOD(*call) == IPC_M_CLONE_ESTABLISH) {
+		// TODO: Currently ignores ports altogether
+		
+		/* Open new connection with fibril, etc. */
+		async_new_connection(call->in_task_id, IPC_GET_ARG5(*call),
+		    callid, call, fallback_port_handler, fallback_port_data);
 		return;
 	}
@@ -2100,4 +2111,76 @@
 	
 	return EOK;
+}
+
+/** Wrapper for making IPC_M_CLONE_ESTABLISH calls using the async framework.
+ *
+ * Ask for a cloned connection to some service.
+ *
+ * @param mgmt Exchange management style.
+ * @param exch Exchange for sending the message.
+ *
+ * @return New session on success or NULL on error.
+ *
+ */
+async_sess_t *async_clone_establish(exch_mgmt_t mgmt, async_exch_t *exch)
+{
+	if (exch == NULL) {
+		errno = ENOENT;
+		return NULL;
+	}
+	
+	async_sess_t *sess = (async_sess_t *) malloc(sizeof(async_sess_t));
+	if (sess == NULL) {
+		errno = ENOMEM;
+		return NULL;
+	}
+	
+	ipc_call_t result;
+	
+	amsg_t *msg = amsg_create();
+	if (!msg) {
+		free(sess);
+		errno = ENOMEM;
+		return NULL;
+	}
+	
+	msg->dataptr = &result;
+	msg->wdata.active = true;
+	
+	ipc_call_async_0(exch->phone, IPC_M_CLONE_ESTABLISH, msg,
+	    reply_received);
+	
+	sysarg_t rc;
+	async_wait_for((aid_t) msg, &rc);
+	
+	if (rc != EOK) {
+		errno = rc;
+		free(sess);
+		return NULL;
+	}
+	
+	int phone = (int) IPC_GET_ARG5(result);
+	
+	if (phone < 0) {
+		errno = phone;
+		free(sess);
+		return NULL;
+	}
+	
+	sess->iface = 0;
+	sess->mgmt = mgmt;
+	sess->phone = phone;
+	sess->arg1 = 0;
+	sess->arg2 = 0;
+	sess->arg3 = 0;
+	
+	fibril_mutex_initialize(&sess->remote_state_mtx);
+	sess->remote_state_data = NULL;
+	
+	list_initialize(&sess->exch_list);
+	fibril_mutex_initialize(&sess->mutex);
+	atomic_set(&sess->refcnt, 0);
+	
+	return sess;
 }
 
@@ -3070,4 +3153,64 @@
 }
 
+/** Wrapper for sending an exchange over different exchange for cloning
+ *
+ * @param exch       Exchange to be used for sending.
+ * @param clone_exch Exchange to be cloned.
+ *
+ */
+int async_exchange_clone(async_exch_t *exch, async_exch_t *clone_exch)
+{
+	return async_req_1_0(exch, IPC_M_CONNECTION_CLONE, clone_exch->phone);
+}
+
+/** Wrapper for receiving the IPC_M_CONNECTION_CLONE calls.
+ *
+ * If the current call is IPC_M_CONNECTION_CLONE then a new
+ * async session is created for the accepted phone.
+ *
+ * @param mgmt Exchange management style.
+ *
+ * @return New async session or NULL on failure.
+ *
+ */
+async_sess_t *async_clone_receive(exch_mgmt_t mgmt)
+{
+	/* Accept the phone */
+	ipc_call_t call;
+	ipc_callid_t callid = async_get_call(&call);
+	int phone = (int) IPC_GET_ARG1(call);
+	
+	if ((IPC_GET_IMETHOD(call) != IPC_M_CONNECTION_CLONE) ||
+	    (phone < 0)) {
+		async_answer_0(callid, EINVAL);
+		return NULL;
+	}
+	
+	async_sess_t *sess = (async_sess_t *) malloc(sizeof(async_sess_t));
+	if (sess == NULL) {
+		async_answer_0(callid, ENOMEM);
+		return NULL;
+	}
+	
+	sess->iface = 0;
+	sess->mgmt = mgmt;
+	sess->phone = phone;
+	sess->arg1 = 0;
+	sess->arg2 = 0;
+	sess->arg3 = 0;
+	
+	fibril_mutex_initialize(&sess->remote_state_mtx);
+	sess->remote_state_data = NULL;
+	
+	list_initialize(&sess->exch_list);
+	fibril_mutex_initialize(&sess->mutex);
+	atomic_set(&sess->refcnt, 0);
+	
+	/* Acknowledge the cloned phone */
+	async_answer_0(callid, EOK);
+	
+	return sess;
+}
+
 /** Wrapper for receiving the IPC_M_CONNECT_TO_ME calls.
  *
Index: uspace/lib/c/generic/ddi.c
===================================================================
--- uspace/lib/c/generic/ddi.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/lib/c/generic/ddi.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -50,4 +50,14 @@
 #include "private/libc.h"
 
+
+/** Return unique device number.
+ *
+ * @return New unique device number.
+ *
+ */
+int device_assign_devno(void)
+{
+	return __SYSCALL0(SYS_DEVICE_ASSIGN_DEVNO);
+}
 
 /** Map a piece of physical memory to task.
Index: uspace/lib/c/generic/irq.c
===================================================================
--- uspace/lib/c/generic/irq.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/lib/c/generic/irq.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -55,29 +55,32 @@
  *
  * @param inr    IRQ number.
+ * @param devno  Device number of the device generating inr.
  * @param method Use this method for notifying me.
  * @param ucode  Top-half pseudocode handler.
  *
- * @return IRQ capability handle returned by the kernel.
- * @return Error code returned by the kernel.
+ * @return Value returned by the kernel.
  *
  */
-int ipc_irq_subscribe(int inr, sysarg_t method, const irq_code_t *ucode)
+int ipc_irq_subscribe(int inr, int devno, sysarg_t method,
+    const irq_code_t *ucode)
 {
 	if (ucode == NULL)
 		ucode = &default_ucode;
 	
-	return __SYSCALL3(SYS_IPC_IRQ_SUBSCRIBE, inr, method, (sysarg_t) ucode);
+	return __SYSCALL4(SYS_IPC_IRQ_SUBSCRIBE, inr, devno, method,
+	    (sysarg_t) ucode);
 }
 
 /** Unsubscribe from IRQ notification.
  *
- * @param cap   IRQ capability handle.
+ * @param inr   IRQ number.
+ * @param devno Device number of the device generating inr.
  *
  * @return Value returned by the kernel.
  *
  */
-int ipc_irq_unsubscribe(int cap)
+int ipc_irq_unsubscribe(int inr, int devno)
 {
-	return __SYSCALL1(SYS_IPC_IRQ_UNSUBSCRIBE, cap);
+	return __SYSCALL2(SYS_IPC_IRQ_UNSUBSCRIBE, inr, devno);
 }
 
Index: uspace/lib/c/include/async.h
===================================================================
--- uspace/lib/c/include/async.h	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/lib/c/include/async.h	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -166,7 +166,7 @@
     sysarg_t, async_port_handler_t, void *, port_id_t *);
 
-extern int async_irq_subscribe(int, async_notification_handler_t, void *,
+extern int async_irq_subscribe(int, int, async_notification_handler_t, void *,
     const irq_code_t *);
-extern int async_irq_unsubscribe(int);
+extern int async_irq_unsubscribe(int, int);
 
 extern int async_event_subscribe(event_type_t, async_notification_handler_t,
@@ -343,4 +343,5 @@
     sysarg_t *, sysarg_t *);
 
+extern async_sess_t *async_clone_establish(exch_mgmt_t, async_exch_t *);
 extern async_sess_t *async_connect_me_to(exch_mgmt_t, async_exch_t *, sysarg_t,
     sysarg_t, sysarg_t);
@@ -471,4 +472,6 @@
     sysarg_t, sysarg_t, sysarg_t, ipc_call_t *);
 
+extern int async_exchange_clone(async_exch_t *, async_exch_t *);
+extern async_sess_t *async_clone_receive(exch_mgmt_t);
 extern async_sess_t *async_callback_receive(exch_mgmt_t);
 extern async_sess_t *async_callback_receive_start(exch_mgmt_t, ipc_call_t *);
Index: uspace/lib/c/include/ipc/irq.h
===================================================================
--- uspace/lib/c/include/ipc/irq.h	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/lib/c/include/ipc/irq.h	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -39,6 +39,6 @@
 #include <abi/ddi/irq.h>
 
-extern int ipc_irq_subscribe(int, sysarg_t, const irq_code_t *);
-extern int ipc_irq_unsubscribe(int);
+extern int ipc_irq_subscribe(int, int, sysarg_t, const irq_code_t *);
+extern int ipc_irq_unsubscribe(int, int);
 
 #endif
Index: uspace/lib/drv/generic/interrupt.c
===================================================================
--- uspace/lib/drv/generic/interrupt.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/lib/drv/generic/interrupt.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -44,13 +44,13 @@
 
 int register_interrupt_handler(ddf_dev_t *dev, int irq,
-    interrupt_handler_t *handler, const irq_code_t *irq_code)
+    interrupt_handler_t *handler, const irq_code_t *pseudocode)
 {
-	return async_irq_subscribe(irq, (async_notification_handler_t) handler,
-	    dev, irq_code);
+	return async_irq_subscribe(irq, dev->handle,
+	    (async_notification_handler_t) handler, dev, pseudocode);
 }
 
-int unregister_interrupt_handler(ddf_dev_t *dev, int cap)
+int unregister_interrupt_handler(ddf_dev_t *dev, int irq)
 {
-	return async_irq_unsubscribe(cap);
+	return async_irq_unsubscribe(irq, dev->handle);
 }
 
Index: uspace/lib/usbhost/src/ddf_helpers.c
===================================================================
--- uspace/lib/usbhost/src/ddf_helpers.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/lib/usbhost/src/ddf_helpers.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -748,6 +748,5 @@
  * @param[in] gen_irq_code IRQ code generator.
  *
- * @return IRQ capability handle on success.
- * @return Negative error code.
+ * @return EOK on success or negative error code
  */
 int hcd_ddf_setup_interrupts(ddf_dev_t *device,
@@ -771,22 +770,22 @@
 
 	/* Register handler to avoid interrupt lockup */
-	const int irq_cap = register_interrupt_handler(device, irq, handler,
-	    &irq_code);
+	int ret = register_interrupt_handler(device, irq, handler, &irq_code);
 	irq_code_clean(&irq_code);
-	if (irq_cap < 0) {
-		usb_log_error("Failed to register interrupt handler: %s.\n",
-		    str_error(irq_cap));
-		return irq_cap;
-	}
-
-	/* Enable interrupts */
-	int ret = hcd_ddf_enable_interrupts(device);
 	if (ret != EOK) {
 		usb_log_error("Failed to register interrupt handler: %s.\n",
 		    str_error(ret));
-		unregister_interrupt_handler(device, irq_cap);
-		return ret;
-	}
-	return irq_cap;
+		return ret;
+	}
+
+	/* Enable interrupts */
+	ret = hcd_ddf_enable_interrupts(device);
+	if (ret != EOK) {
+		usb_log_error("Failed to register interrupt handler: %s.\n",
+		    str_error(ret));
+		unregister_interrupt_handler(device, irq);
+		return ret;
+	}
+	assert(irq > 0);
+	return irq;
 }
 
@@ -883,8 +882,7 @@
 	interrupt_handler_t *irq_handler =
 	    driver->irq_handler ? driver->irq_handler : ddf_hcd_gen_irq_handler;
-	const int irq_cap = hcd_ddf_setup_interrupts(device, &hw_res,
-	    irq_handler, driver->irq_code_gen);
-	bool irqs_enabled = !(irq_cap < 0);
-	if (irqs_enabled) {
+	const int irq = hcd_ddf_setup_interrupts(device, &hw_res, irq_handler,
+	    driver->irq_code_gen);
+	if (!(irq < 0)) {
 		usb_log_debug("Hw interrupts enabled.\n");
 	}
@@ -901,5 +899,5 @@
 	/* Init hw driver */
 	hcd_t *hcd = dev_to_hcd(device);
-	ret = driver->init(hcd, &hw_res, irqs_enabled);
+	ret = driver->init(hcd, &hw_res, !(irq < 0));
 	hw_res_list_parsed_clean(&hw_res);
 	if (ret != EOK) {
@@ -909,5 +907,5 @@
 
 	/* Need working irq replacement to setup root hub */
-	if (!irqs_enabled && hcd->ops.status_hook) {
+	if ((irq < 0) && hcd->ops.status_hook) {
 		hcd->polling_fibril = fibril_create(interrupt_polling, hcd);
 		if (hcd->polling_fibril == 0) {
@@ -918,5 +916,5 @@
 		fibril_add_ready(hcd->polling_fibril);
 		usb_log_warning("Failed to enable interrupts: %s."
-		    " Falling back to polling.\n", str_error(irq_cap));
+		    " Falling back to polling.\n", str_error(irq));
 	}
 
@@ -932,5 +930,5 @@
 irq_unregister:
 		/* Unregistering non-existent should be ok */
-		unregister_interrupt_handler(device, irq_cap);
+		unregister_interrupt_handler(device, irq);
 		hcd_ddf_clean_hc(device);
 		return ret;
Index: uspace/srv/hid/input/port/msim.c
===================================================================
--- uspace/srv/hid/input/port/msim.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/srv/hid/input/port/msim.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -97,5 +97,6 @@
 	msim_ranges[0].base = paddr;
 	msim_cmds[0].addr = (void *) paddr;
-	async_irq_subscribe(inr, msim_irq_handler, NULL, &msim_kbd);
+	async_irq_subscribe(inr, device_assign_devno(), msim_irq_handler, NULL,
+	    &msim_kbd);
 	
 	return 0;
Index: uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c
===================================================================
--- uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -137,5 +137,6 @@
 	    (void *) ts->paddr, inr);
 
-	async_irq_subscribe(inr, s3c24xx_ts_irq_handler, NULL, &ts_irq_code);
+	async_irq_subscribe(inr, device_assign_devno(), s3c24xx_ts_irq_handler,
+	    NULL, &ts_irq_code);
 
 	s3c24xx_ts_wait_for_int_mode(ts, updn_down);
Index: uspace/srv/hw/bus/cuda_adb/cuda_adb.c
===================================================================
--- uspace/srv/hw/bus/cuda_adb/cuda_adb.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/srv/hw/bus/cuda_adb/cuda_adb.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -282,5 +282,6 @@
 	cuda_irq_code.ranges[0].base = (uintptr_t) instance->cuda_physical;
 	cuda_irq_code.cmds[0].addr = (void *) &((cuda_t *) instance->cuda_physical)->ifr;
-	async_irq_subscribe(10, cuda_irq_handler, NULL, &cuda_irq_code);
+	async_irq_subscribe(10, device_assign_devno(), cuda_irq_handler, NULL,
+	    &cuda_irq_code);
 
 	/* Enable SR interrupt. */
Index: uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c
===================================================================
--- uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -193,5 +193,6 @@
 	    (void *) uart->paddr, inr);
 
-	async_irq_subscribe(inr, s3c24xx_uart_irq_handler, NULL, &uart_irq_code);
+	async_irq_subscribe(inr, device_assign_devno(), s3c24xx_uart_irq_handler,
+	    NULL, &uart_irq_code);
 
 	/* Enable FIFO, Tx trigger level: empty, Rx trigger level: 1 byte. */
